Index: /branches/2017/dev_r7963_nemo_v3_6_AGRIF-3_AGRIFVVL/NEMOGCM/CONFIG/VORTEX/EXP00/1_namelist_cfg
===================================================================
--- /branches/2017/dev_r7963_nemo_v3_6_AGRIF-3_AGRIFVVL/NEMOGCM/CONFIG/VORTEX/EXP00/1_namelist_cfg	(revision 8012)
+++ /branches/2017/dev_r7963_nemo_v3_6_AGRIF-3_AGRIFVVL/NEMOGCM/CONFIG/VORTEX/EXP00/1_namelist_cfg	(revision 8013)
@@ -9,5 +9,5 @@
    nn_date0    = 19500101     !  initial date
    nn_it000    =        1     !  first time step
-   nn_itend    =    16200     !  last  time step (std 5475)
+   nn_itend    =    18000     !  last  time step (std 5475)
    nn_stock    =        0     !  frequency of creation of a restart file (modulo referenced to 1)
    nn_istate   =        0     !  output the initial state (1) or not (0)
@@ -18,6 +18,6 @@
    nn_cln_update =    1    !  baroclinic update frequency
    ln_spc_dyn    = .true.  !  use 0 as special value for dynamics
-   rn_sponge_tra =  300.   !  coefficient for tracer   sponge layer [m2/s]
-   rn_sponge_dyn =  300.   !  coefficient for dynamics sponge layer [m2/s]
+   rn_sponge_tra =  100.   !  coefficient for tracer   sponge layer [m2/s]
+   rn_sponge_dyn =  400.   !  coefficient for dynamics sponge layer [m2/s]
 /
 !-----------------------------------------------------------------------
@@ -27,9 +27,9 @@
    cp_cfz      =      ''               !  name of the zoom of configuration
    jp_cfg      =       0               !  resolution of the configuration
-   jpidta      =      61               !  1st lateral dimension ( >= jpi )
-   jpjdta      =      61               !  2nd    "         "    ( >= jpj )
+   jpidta      =      63               !  1st lateral dimension ( >= jpi )
+   jpjdta      =      63               !  2nd    "         "    ( >= jpj )
    jpkdta      =      11               !  number of levels      ( >= jpk )
-   jpiglo      =      61               !  1st dimension of global domain --> i =jpidta
-   jpjglo      =      61               !  2nd    -                  -    --> j  =jpjdta
+   jpiglo      =      63               !  1st dimension of global domain --> i =jpidta
+   jpjglo      =      63               !  2nd    -                  -    --> j  =jpjdta
    jpizoom     =       1               !  left bottom (i,j) indices of the zoom
    jpjzoom     =       1               !  in data domain indices
@@ -76,5 +76,5 @@
    ln_bt_nn_auto =    .FALSE.          !  Set nn_baro automatically to be just below
                                        !  a user defined maximum courant number (rn_bt_cmax)
-   nn_baro       =    20               !  Number of iterations of barotropic mode
+   nn_baro       =    24               !  Number of iterations of barotropic mode
                                        !  during rn_rdt seconds. Only used if ln_bt_nn_auto=F
 /
@@ -179,6 +179,6 @@
 !-----------------------------------------------------------------------
    ln_traadv_cen2   =  .false.   !  2nd order centered scheme
-   ln_traadv_tvd    =  .true.    !  TVD scheme
-   ln_traadv_ubs    =  .false.   !  UBS scheme
+   ln_traadv_tvd    =  .false.   !  TVD scheme
+   ln_traadv_ubs    =  .true.    !  UBS scheme
 /
 !-----------------------------------------------------------------------
@@ -196,10 +196,9 @@
    !                       !  Operator type:
    ln_traldf_lap    =  .false.  !  laplacian operator
-   ln_traldf_bilap  =  .true.   !  bilaplacian operator
+   ln_traldf_bilap  =  .false.  !  bilaplacian operator
    !                       !  Direction of action:
    ln_traldf_level  =  .false.  !  iso-level
    ln_traldf_hor    =  .true.   !  horizontal (geopotential)   (needs "key_ldfslp" when ln_sco=T)
    ln_traldf_iso    =  .false.  !  iso-neutral                 (needs "key_ldfslp")
-   rn_aht_0         =   -2.e9  !  horizontal eddy diffusivity for tracers [m2/s]
 /
 !-----------------------------------------------------------------------
@@ -242,6 +241,6 @@
 &namzdf        !   vertical physics
 !-----------------------------------------------------------------------
-   rn_avm0     =    1.e-4  !  vertical eddy viscosity   [m2/s]          (background Kz if not "key_zdfcst")
-   rn_avt0     =    1.e-5  !  vertical eddy diffusivity [m2/s]          (background Kz if not "key_zdfcst")
+   rn_avm0     =    0.e-4  !  vertical eddy viscosity   [m2/s]          (background Kz if not "key_zdfcst")
+   rn_avt0     =    0.e-5  !  vertical eddy diffusivity [m2/s]          (background Kz if not "key_zdfcst")
    ln_zdfevd   = .true.    !  enhanced vertical diffusion (evd) (T) or not (F)
    nn_evdm     =    0      !  evd apply on tracer (=0) or on tracer and momentum (=1)
@@ -268,6 +267,6 @@
     ln_tra_dmp    =.false.,.false.,.false.,.false.      !  open boudaries conditions for tracers
     ln_dyn3d_dmp  =.false.,.false.,.false.,.false.      !  open boundary condition for baroclinic velocities
-    rn_time_dmp   =  1., 1., 1., 1.             ! Damping time scale in days
-    rn_time_dmp_out =  30., 30., 30., 30.       ! Outflow damping time scale
+    rn_time_dmp   =  100., 100., 100., 100.             ! Damping time scale in days
+    rn_time_dmp_out =  100., 100., 100., 100.       ! Outflow damping time scale
     nn_rimwidth   = 1, 1, 1, 1                  !  width of the relaxation zone
     ln_vol        = .false.               !  total volume correction (see nn_volctl parameter)
Index: /branches/2017/dev_r7963_nemo_v3_6_AGRIF-3_AGRIFVVL/NEMOGCM/CONFIG/VORTEX/EXP00/AGRIF_FixedGrids.in
===================================================================
--- /branches/2017/dev_r7963_nemo_v3_6_AGRIF-3_AGRIFVVL/NEMOGCM/CONFIG/VORTEX/EXP00/AGRIF_FixedGrids.in	(revision 8012)
+++ /branches/2017/dev_r7963_nemo_v3_6_AGRIF-3_AGRIFVVL/NEMOGCM/CONFIG/VORTEX/EXP00/AGRIF_FixedGrids.in	(revision 8013)
@@ -1,5 +1,3 @@
 1
-20 39 20 39 3 3 3 
+21 40 21 40 3 3 3  
 0
-10 49 10 49 3 3 3
-0
Index: /branches/2017/dev_r7963_nemo_v3_6_AGRIF-3_AGRIFVVL/NEMOGCM/CONFIG/VORTEX/EXP00/namelist_cfg
===================================================================
--- /branches/2017/dev_r7963_nemo_v3_6_AGRIF-3_AGRIFVVL/NEMOGCM/CONFIG/VORTEX/EXP00/namelist_cfg	(revision 8012)
+++ /branches/2017/dev_r7963_nemo_v3_6_AGRIF-3_AGRIFVVL/NEMOGCM/CONFIG/VORTEX/EXP00/namelist_cfg	(revision 8013)
@@ -9,7 +9,15 @@
    nn_date0    = 19500101     !  initial date
    nn_it000    =        1     !  first time step
-   nn_itend    =     5400     !  last  time step (std 5475)
+   nn_itend    =     6000     !  last  time step (std 5475)
    nn_stock    =        0     !  frequency of creation of a restart file (modulo referenced to 1)
    nn_istate   =        0     !  output the initial state (1) or not (0)
+/
+!-----------------------------------------------------------------------
+&namagrif      !  AGRIF zoom                                            ("key_agrif")
+!-----------------------------------------------------------------------
+   nn_cln_update =    1    !  baroclinic update frequency
+   ln_spc_dyn    = .true.  !  use 0 as special value for dynamics
+   rn_sponge_tra =  100.   !  coefficient for tracer   sponge layer [m2/s]
+   rn_sponge_dyn =  400.   !  coefficient for dynamics sponge layer [m2/s]
 /
 !-----------------------------------------------------------------------
@@ -19,9 +27,9 @@
    cp_cfz      =      ''               !  name of the zoom of configuration
    jp_cfg      =       0               !  resolution of the configuration
-   jpidta      =      61               !  1st lateral dimension ( >= jpi )
-   jpjdta      =      61               !  2nd    "         "    ( >= jpj )
+   jpidta      =      63               !  1st lateral dimension ( >= jpi )
+   jpjdta      =      63               !  2nd    "         "    ( >= jpj )
    jpkdta      =      11               !  number of levels      ( >= jpk )
-   jpiglo      =      61               !  1st dimension of global domain --> i =jpidta
-   jpjglo      =      61               !  2nd    -                  -    --> j  =jpjdta
+   jpiglo      =      63               !  1st dimension of global domain --> i =jpidta
+   jpjglo      =      63               !  2nd    -                  -    --> j  =jpjdta
    jpizoom     =       1               !  left bottom (i,j) indices of the zoom
    jpjzoom     =       1               !  in data domain indices
@@ -68,5 +76,5 @@
    ln_bt_nn_auto =    .FALSE.          !  Set nn_baro automatically to be just below
                                        !  a user defined maximum courant number (rn_bt_cmax)
-   nn_baro       =    20               !  Number of iterations of barotropic mode
+   nn_baro       =    24               !  Number of iterations of barotropic mode
                                        !  during rn_rdt seconds. Only used if ln_bt_nn_auto=F
 /
@@ -171,6 +179,6 @@
 !-----------------------------------------------------------------------
    ln_traadv_cen2   =  .false.   !  2nd order centered scheme
-   ln_traadv_tvd    =  .true.    !  TVD scheme
-   ln_traadv_ubs    =  .false.   !  UBS scheme
+   ln_traadv_tvd    =  .false.   !  TVD scheme
+   ln_traadv_ubs    =  .true.    !  UBS scheme
 /
 !-----------------------------------------------------------------------
@@ -188,10 +196,9 @@
    !                       !  Operator type:
    ln_traldf_lap    =  .false.  !  laplacian operator
-   ln_traldf_bilap  =  .true.   !  bilaplacian operator
+   ln_traldf_bilap  =  .false.  !  bilaplacian operator
    !                       !  Direction of action:
    ln_traldf_level  =  .false.  !  iso-level
    ln_traldf_hor    =  .true.   !  horizontal (geopotential)   (needs "key_ldfslp" when ln_sco=T)
    ln_traldf_iso    =  .false.  !  iso-neutral                 (needs "key_ldfslp")
-   rn_aht_0         =   -5.e10  !  horizontal eddy diffusivity for tracers [m2/s]
 /
 !-----------------------------------------------------------------------
@@ -234,6 +241,6 @@
 &namzdf        !   vertical physics
 !-----------------------------------------------------------------------
-   rn_avm0     =    1.e-4  !  vertical eddy viscosity   [m2/s]          (background Kz if not "key_zdfcst")
-   rn_avt0     =    1.e-5  !  vertical eddy diffusivity [m2/s]          (background Kz if not "key_zdfcst")
+   rn_avm0     =    0.e-4  !  vertical eddy viscosity   [m2/s]          (background Kz if not "key_zdfcst")
+   rn_avt0     =    0.e-5  !  vertical eddy diffusivity [m2/s]          (background Kz if not "key_zdfcst")
    ln_zdfevd   = .true.    !  enhanced vertical diffusion (evd) (T) or not (F)
    nn_evdm     =    0      !  evd apply on tracer (=0) or on tracer and momentum (=1)
@@ -242,5 +249,5 @@
 !-----------------------------------------------------------------------
 &nambdy        !  unstructured open boundaries                          ("key_bdy")
-    nb_bdy         = 4                    !  number of open boundary sets
+    nb_bdy         = 0                    !  number of open boundary sets
     ln_coords_file = .false.,.false.,.false.,.false.      !  =T : read bdy coordinates from file
     cn_coords_file = '','','',''          !  bdy coordinates files