Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limctl.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limctl.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limctl.F90	(revision 8016)
@@ -25,5 +25,4 @@
 
    USE lib_mpp         ! MPP library
-   USE wrk_nemo        ! work arrays
    USE timing          ! Timing
    USE in_out_manager  ! I/O manager
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limdyn.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limdyn.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limdyn.F90	(revision 8016)
@@ -22,5 +22,4 @@
    USE lbclnk           ! lateral boundary conditions - MPP exchanges
    USE lib_mpp          ! MPP library
-   USE wrk_nemo         ! work arrays
    USE in_out_manager   ! I/O manager
    USE lib_fortran      ! glob_sum
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limthd_sal.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limthd_sal.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limthd_sal.F90	(revision 8016)
@@ -22,5 +22,4 @@
    USE in_out_manager ! I/O manager
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! work arrays
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90	(revision 8016)
@@ -21,5 +21,4 @@
    USE limitd_th
    USE limvar
-   USE wrk_nemo        ! work arrays
    USE timing          ! Timing
    USE limcons         ! conservation tests
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90	(revision 8016)
@@ -22,5 +22,4 @@
    USE limvar
    USE lbclnk          ! lateral boundary condition - MPP exchanges
-   USE wrk_nemo        ! work arrays
    USE timing          ! Timing
    USE limcons         ! conservation tests
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/NST_SRC/agrif_opa_update.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/NST_SRC/agrif_opa_update.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/NST_SRC/agrif_opa_update.F90	(revision 8016)
@@ -10,5 +10,4 @@
    USE in_out_manager  ! I/O manager
    USE lib_mpp
-   USE wrk_nemo  
    USE zdf_oce        ! vertical physics: ocean variables 
 
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/NST_SRC/agrif_top_interp.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/NST_SRC/agrif_top_interp.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/NST_SRC/agrif_top_interp.F90	(revision 8016)
@@ -9,5 +9,4 @@
    USE trc
    USE lib_mpp
-   USE wrk_nemo  
 
    IMPLICIT NONE
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/NST_SRC/agrif_top_sponge.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/NST_SRC/agrif_top_sponge.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/NST_SRC/agrif_top_sponge.F90	(revision 8016)
@@ -24,5 +24,4 @@
    USE in_out_manager
    USE lib_mpp
-   USE wrk_nemo  
 
    IMPLICIT NONE
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/NST_SRC/agrif_top_update.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/NST_SRC/agrif_top_update.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/NST_SRC/agrif_top_update.F90	(revision 8016)
@@ -17,5 +17,4 @@
    USE dom_oce
    USE agrif_oce
-   USE wrk_nemo  
 
    IMPLICIT NONE
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DIA/dia25h.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DIA/dia25h.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DIA/dia25h.F90	(revision 8016)
@@ -10,5 +10,4 @@
    USE in_out_manager  ! I/O units
    USE iom             ! I/0 library
-   USE wrk_nemo        ! working arrays
 #if defined key_zdftke 
    USE zdf_oce, ONLY: en
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DOM/depth_e3.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DOM/depth_e3.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DOM/depth_e3.F90	(revision 8016)
@@ -20,5 +20,4 @@
    USE lbclnk            ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp           ! distributed memory computing library
-   USE wrk_nemo          ! Memory allocation
    USE timing            ! Timing
 
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90	(revision 8016)
@@ -45,5 +45,4 @@
    USE lbclnk         ! ocean lateral boundary condition (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE wrk_nemo       ! Memory Allocation
    USE timing         ! Timing
 
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DOM/istate.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DOM/istate.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DOM/istate.F90	(revision 8016)
@@ -36,5 +36,4 @@
    USE lib_mpp         ! MPP library
    USE restart         ! restart
-   USE wrk_nemo        ! Memory allocation
    USE timing          ! Timing
 
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DYN/divhor.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DYN/divhor.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/DYN/divhor.F90	(revision 8016)
@@ -29,5 +29,4 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp         ! MPP library
-   USE wrk_nemo        ! Memory Allocation
    USE timing          ! Timing
 
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/FLO/flowri.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/FLO/flowri.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/FLO/flowri.F90	(revision 8016)
@@ -35,5 +35,4 @@
 
    ! Following are only workspace arrays but shape is not (jpi,jpj) and
-   ! therefore make them module arrays rather than replacing with wrk_nemo
    ! member arrays.
    REAL(wp), ALLOCATABLE, DIMENSION(:) ::   zlon , zlat, zdep   ! 2D workspace
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 8016)
@@ -24,5 +24,4 @@
    USE lib_mpp         ! distribued memory computing library
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE wrk_nemo        ! Memory Allocation
 
    IMPLICIT NONE
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 8016)
@@ -46,5 +46,4 @@
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
    USE prtctl         ! Print control
-   USE wrk_nemo       ! Memory Allocation
    USE lbclnk         ! ocean lateral boundary conditions
    USE timing         ! Timing
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde.F90	(revision 8016)
@@ -22,5 +22,4 @@
    USE lbclnk          ! lateral boundary conditions (or mpp link)
    USE lib_mpp         ! MPP library
-   USE wrk_nemo        ! Memory allocation
    USE timing          ! Timing
 
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/USR/usrdef_zgr.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/USR/usrdef_zgr.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/USR/usrdef_zgr.F90	(revision 8016)
@@ -23,5 +23,4 @@
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE wrk_nemo       ! Memory allocation
    USE timing         ! Timing
 
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/SAS_SRC/diawri.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/SAS_SRC/diawri.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/SAS_SRC/diawri.F90	(revision 8016)
@@ -45,5 +45,4 @@
    USE lib_mpp         ! MPP library
    USE timing          ! preformance summary
-   USE wrk_nemo        ! working array
 
    IMPLICIT NONE
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 8015)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 8016)
@@ -19,5 +19,4 @@
 
    USE in_out_manager                           !* IO manager *
-   USE wrk_nemo                                 !* Memory Allocation *
    USE timing                                   !* Timing * 
    USE lib_mpp                                  !* MPP library                         