Index: /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90
===================================================================
--- /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90	(revision 8025)
+++ /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90	(revision 8026)
@@ -122,7 +122,5 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   sprecip           !: solid precipitation                          [Kg/m2/s]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fr_i              !: ice fraction = 1 - lead fraction      (between 0 to 1)
-#if defined key_cpl_carbon_cycle
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   atm_co2           !: atmospheric pCO2                             [ppm]
-#endif
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: xcplmask          !: coupling mask for ln_mixcpl (warning: allocated in sbccpl)
 
Index: /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90
===================================================================
--- /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 8025)
+++ /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 8026)
@@ -697,6 +697,6 @@
       CASE( -1, 0 )                !==  polynomial TEOS-10 / EOS-80 ==!
          !
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
+         DO jj = 1, jpj
+            DO ji = 1, jpi
                !
                zh  = pdep(ji,jj) * r1_Z0                                  ! depth
@@ -750,11 +750,8 @@
          END DO
          !
-         CALL lbc_lnk( pab(:,:,jp_tem), 'T', 1. )                    ! Lateral boundary conditions
-         CALL lbc_lnk( pab(:,:,jp_sal), 'T', 1. )                    
-         !
       CASE( 1 )                  !==  simplified EOS  ==!
          !
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
+         DO jj = 1, jpj
+            DO ji = 1, jpi
                !
                zt    = pts  (ji,jj,jp_tem) - 10._wp   ! pot. temperature anomaly (t-T0)
@@ -770,7 +767,4 @@
             END DO
          END DO
-         !
-         CALL lbc_lnk( pab(:,:,jp_tem), 'T', 1. )                    ! Lateral boundary conditions
-         CALL lbc_lnk( pab(:,:,jp_sal), 'T', 1. )                    
          !
       CASE DEFAULT
Index: /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm_substitute.h90
===================================================================
--- /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm_substitute.h90	(revision 8025)
+++ /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm_substitute.h90	(revision 8026)
@@ -5,5 +5,5 @@
    !!      with a constant or 1D or 2D or 3D array, using CPP macro.
    !!----------------------------------------------------------------------
-#if defined key_zdfddm
+#if defined key_zdfddm && ! defined key_offline
 !   'key_zdfddm' :                      avs: 3D array defined in zdfddm module
 #   define   fsavs(i,j,k)       avs(i,j,k)
Index: /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/trc_oce.F90
===================================================================
--- /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/trc_oce.F90	(revision 8025)
+++ /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/trc_oce.F90	(revision 8026)
@@ -23,5 +23,5 @@
    PUBLIC   trc_oce_alloc      ! function called by nemogcm.F90
 
-   INTEGER , PUBLIC                                      ::   nn_dttrc      !: frequency of step on passive tracers
+   INTEGER , PUBLIC                                      ::   nn_dttrc = 1  !: frequency of step on passive tracers
    REAL(wp), PUBLIC                                      ::   r_si2         !: largest depth of extinction (blue & 0.01 mg.m-3)  (RGB)
    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::   etot3         !: light absortion coefficient
Index: /branches/2015/nemo_v3_6_STABLE/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena
===================================================================
--- /branches/2015/nemo_v3_6_STABLE/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena	(revision 8025)
+++ /branches/2015/nemo_v3_6_STABLE/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena	(revision 8026)
@@ -4,5 +4,5 @@
 #BSUB -n NPROCS
 #BSUB -a poe
-#BSUB -J MPI_config
+#BSUB -J NEMO_SETTE
 #BSUB -o poe.stdout.%J
 #BSUB -e poe.stderr.%J
Index: /branches/2015/nemo_v3_6_STABLE/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena_xios
===================================================================
--- /branches/2015/nemo_v3_6_STABLE/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena_xios	(revision 8025)
+++ /branches/2015/nemo_v3_6_STABLE/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena_xios	(revision 8026)
@@ -4,5 +4,5 @@
 #BSUB -n TOTAL_NPROCS
 #BSUB -a poe
-#BSUB -J MPI_config
+#BSUB -J NEMO_SETTE
 #BSUB -o poe.stdout.%J
 #BSUB -e poe.stderr.%J