Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml	(revision 8131)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml	(revision 8132)
@@ -76,18 +76,33 @@
       <!-- MEDUSA : variables available with key_medusa -->
        <field id="CHN"      long_name="Chl-a concentration in non-diatom phytoplankton"   unit="mg Chl/m3" />
+       <field id="CHN_E3T"  long_name="CHN * E3T"                                         unit="mg Chl/m2"  > CHN * e3t </field > 
        <field id="CHD"      long_name="Chl-a concentration in     diatom phytoplankton"   unit="mg Chl/m3" />
+       <field id="CHD_E3T"  long_name="CHD * E3T"                                         unit="mg Chl/m2"  > CHD * e3t </field >
        <field id="PHN"      long_name="non-diatom phytoplankton"                          unit="mmol-N/m3" />
+       <field id="PHN_E3T"  long_name="PHN * E3T"                                         unit="mmol-N/m2"  > PHN * e3t </field >
        <field id="PHD"      long_name="diatom     phytoplankton"                          unit="mmol-N/m3" />
+       <field id="PHD_E3T"  long_name="PHD * E3T"                                         unit="mmol-N/m2"  > PHD * e3t </field >
        <field id="ZMI"      long_name="micro zooplankton"                                 unit="mmol-N/m3" />
+       <field id="ZMI_E3T"  long_name="ZMI * E3T"                                         unit="mmol-N/m2"  > ZMI * e3t </field >
        <field id="ZME"      long_name="meso  zooplankton"                                 unit="mmol-N/m3" />
+       <field id="ZME_E3T"  long_name="ZME * E3T"                                         unit="mmol-N/m2"  > ZME * e3t </field >
        <field id="DIN"      long_name="dissolved inorganic nitrogen"                      unit="mmol-N/m3" />
+       <field id="DIN_E3T"  long_name="DIN * E3T"                                         unit="mmol-N/m2"  > DIN * e3t </field >
        <field id="SIL"      long_name="dissolved silicic acid"                            unit="mmolSi/m3" />
+       <field id="SIL_E3T"  long_name="SIL * E3T"                                         unit="mmolSi/m2"  > SIL * e3t </field >
        <field id="FER"      long_name="dissolved iron"                                    unit="mmolFe/m3" />
+       <field id="FER_E3T"  long_name="FER * E3T"                                         unit="mmolFe/m2"  > FER * e3t </field >
        <field id="DET"      long_name="detrital nitrogen"                                 unit="mmol-N/m3" />
+       <field id="DET_E3T"  long_name="DET * E3T"                                         unit="mmol-N/m2"  > DET * e3t </field >
        <field id="PDS"      long_name="biogenic silicon in diatom phytoplankton"          unit="mmolSi/m3" />
+       <field id="PDS_E3T"  long_name="PDS * E3T"                                         unit="mmolSi/m2"  > PDS * e3t </field >
        <field id="DTC"      long_name="detrital carbon"                                   unit="mmol-C/m3" />
+       <field id="DTC_E3T"  long_name="DTC * E3T"                                         unit="mmol-C/m2"  > DTC * e3t </field >
        <field id="DiC"      long_name="dissolved inorganic carbon"                        unit="mmol-C/m3" />
+       <field id="DiC_E3T"  long_name="DiC * E3T"                                         unit="mmol-C/m2"  > DiC * e3t </field >
        <field id="ALK"      long_name="alkalinity"                                        unit="meq/m3"    />
+       <field id="ALK_E3T"  long_name="ALK * E3T"                                         unit="meq/m2"     > ALK * e3t </field >
        <field id="OXY"      long_name="dissolved oxygen"                                  unit="mmolO2/m3" />
+       <field id="OXY_E3T"  long_name="OXY * E3T"                                         unit="mmolO2/m2"  > OXY * e3t </field >
 
       <!-- Ideal traceurs : variables available with key_idtra -->
@@ -528,19 +543,34 @@
 
     <field_group id="groupMEDUSA" >
-      <field field_ref="CHN"   name="CHN"   />
-      <field field_ref="CHD"   name="CHD"   />
-      <field field_ref="PHN"   name="PHN"   />
-      <field field_ref="PHD"   name="PHD"   />
-      <field field_ref="ZMI"   name="ZMI"   />
-      <field field_ref="ZME"   name="ZME"   />
-      <field field_ref="DIN"   name="DIN"   />
-      <field field_ref="SIL"   name="SIL"   />
-      <field field_ref="FER"   name="FER"   />
-      <field field_ref="DET"   name="DET"   />
-      <field field_ref="PDS"   name="PDS"   />
-      <field field_ref="DTC"   name="DTC"   />
-      <field field_ref="DiC"   name="DIC"   />
-      <field field_ref="ALK"   name="ALK"   />
-      <field field_ref="OXY"   name="OXY"   />
+      <field field_ref="CHN"     name="CHN"      />
+      <field field_ref="CHN_E3T" name="CHN_E3T"  />
+      <field field_ref="CHD"     name="CHD"      />
+      <field field_ref="CHD_E3T" name="CHD_E3T"  />
+      <field field_ref="PHN"     name="PHN"      />
+      <field field_ref="PHN_E3T" name="PHN_E3T"  />
+      <field field_ref="PHD"     name="PHD"      />
+      <field field_ref="PHD_E3T" name="PHD_E3T"  />
+      <field field_ref="ZMI"     name="ZMI"      />
+      <field field_ref="ZMI_E3T" name="ZMI_E3T"  />
+      <field field_ref="ZME"     name="ZME"      />
+      <field field_ref="ZME_E3T" name="ZME_E3T"  />
+      <field field_ref="DIN"     name="DIN"      />
+      <field field_ref="DIN_E3T" name="DIN_E3T"  />
+      <field field_ref="SIL"     name="SIL"      />
+      <field field_ref="SIL_E3T" name="SIL_E3T"  />
+      <field field_ref="FER"     name="FER"      />
+      <field field_ref="FER_E3T" name="FER_E3T"  />
+      <field field_ref="DET"     name="DET"      />
+      <field field_ref="DET_E3T" name="DET_E3T"  />
+      <field field_ref="PDS"     name="PDS"      />
+      <field field_ref="PDS_E3T" name="PDS_E3T"  />
+      <field field_ref="DTC"     name="DTC"      />
+      <field field_ref="DTC_E3T" name="DTC_E3T"  />
+      <field field_ref="DiC"     name="DIC"      />
+      <field field_ref="DiC_E3T" name="DIC_E3T"  />
+      <field field_ref="ALK"     name="ALK"      />
+      <field field_ref="ALK_E3T" name="ALK_E3T"  />
+      <field field_ref="OXY"     name="OXY"      />
+      <field field_ref="OXY_E3T" name="OXY_E3T"  />
       </field_group>
 
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/sms_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/sms_medusa.F90	(revision 8131)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/sms_medusa.F90	(revision 8132)
@@ -243,7 +243,8 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: zn_co2_flx  !: 2D avg fx co2 (now)
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: za_co2_flx  !: 2D avg fx co2 (after)
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: zb_dms_srf  !: 2D avg fx co2 (before)
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: zn_dms_srf  !: 2D avg fx co2 (now)
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: za_dms_srf  !: 2D avg fx co2 (after)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: zb_dms_srf  !: 2D avg sfr dms (before)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: zn_dms_srf  !: 2D avg sfr dms (now)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: za_dms_srf  !: 2D avg srf dms (after)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: zn_chl_srf  !: 2D avg srf chl (now)
 
 #endif
@@ -485,5 +486,5 @@
          &      za_co2_flx(jpi,jpj)  ,                              &
          &      zb_dms_srf(jpi,jpj)  , zn_dms_srf(jpi,jpj)  ,       &           
-         &      za_dms_srf(jpi,jpj)  ,                           STAT=ierr(5) )
+         &      za_dms_srf(jpi,jpj)  , zn_chl_srf(jpi,jpj)  ,    STAT=ierr(5) )
 # endif
       !* 2D fields of miscellaneous parameters
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 8131)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 8132)
@@ -95,5 +95,5 @@
       !! JPALM (27-06-2016): add lk_oasis for CO2 and DMS coupling with atm
       USE sbc_oce, ONLY: lk_oasis
-      USE oce,     ONLY: CO2Flux_out_cpl, DMS_out_cpl, PCO2a_in_cpl
+      USE oce,     ONLY: CO2Flux_out_cpl, DMS_out_cpl, PCO2a_in_cpl, chloro_out_cpl
 
       IMPLICIT NONE
@@ -4809,5 +4809,12 @@
                      IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 1'
                      CALL flush(numout)
-#   endif
+#   endif            
+                     !! JPALM -- 02-06-2017 --
+                     !! add Chl surf coupling
+                     !! no need to output, just pass to cpl var
+                     IF (lk_oasis) THEN
+                          zn_chl_srf(:,:) = trn(:,:,1,jpchd) + trn(:,:,1,jpchn)
+                         chloro_out_cpl(:,:) = zn_chl_srf(:,:)        !! Coupling Chl
+                     END IF
                      IF( med_diag%MED_QSR%dgsave ) THEN
                          CALL iom_put( "MED_QSR"  , qsr ) !
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcdms_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcdms_medusa.F90	(revision 8131)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcdms_medusa.F90	(revision 8132)
@@ -40,5 +40,5 @@
 !
    SUBROUTINE trc_dms_medusa( chn, chd, mld, xqsr, xdin, xlim,  &  !! inputs
-     &  dms_andr, dms_simo, dms_aran, dms_hall dms_andm)           !! outputs
+     &  dms_andr, dms_simo, dms_aran, dms_hall, dms_andm)           !! outputs
 !      
 !=======================================================================
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90	(revision 8131)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90	(revision 8132)
@@ -28,5 +28,5 @@
    USE trcsed_medusa
    USE sbc_oce, ONLY: lk_oasis
-   USE oce,     ONLY: CO2Flux_out_cpl, DMS_out_cpl  !! Coupling variable
+   USE oce,     ONLY: CO2Flux_out_cpl, DMS_out_cpl, chloro_out_cpl  !! Coupling variable
 
 
@@ -265,10 +265,11 @@
       !!---------------------------------------------------------------------
       !!
-      zb_co2_flx(:,:)  = 0.0  !! CHN
+      zb_co2_flx(:,:)  = 0.0  !! CO2 flx
       zn_co2_flx(:,:)  = 0.0
       za_co2_flx(:,:)  = 0.0
-      zb_dms_srf(:,:)  = 0.0  !! CHD
+      zb_dms_srf(:,:)  = 0.0  !! DMS srf
       zn_dms_srf(:,:)  = 0.0
       za_dms_srf(:,:)  = 0.0
+      zn_chl_srf(:,:)  = 0.0  !! Chl srf
       !!
       IF(lwp) WRITE(numout,*) ' trc_ini_medusa: DMS and CO2 flux (UKESM) initialised to zero'
@@ -277,4 +278,5 @@
          CO2Flux_out_cpl(:,:) =  zn_co2_flx(:,:)   !! Coupling variable
          DMS_out_cpl(:,:)     =  zn_dms_srf(:,:)   !! Coupling variable
+         chloro_out_cpl(:,:)  =  zn_chl_srf(:,:)   !! Coupling variable
       END IF
       !!
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 8131)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 8132)
@@ -131,6 +131,6 @@
                   ZE_MES_C, ZE_MESDC, ZE_EXCR, ZE_RESP, ZE_GROW, MDETC, GMIDC, GMEDC,                &
                   INT_ZMI, INT_ZME, INT_DET, INT_DTC, DMS_SURF, DMS_ANDR, DMS_SIMO, DMS_ARAN,        &
-                  DMS_HALL, ATM_XCO2, OCN_FCO2, ATM_FCO2, OCN_RHOSW, OCN_SCHCO2, OCN_KWCO2,          &
-                  OCN_K0, CO2STARAIR, OCN_DPCO2,                                                     & ! end of regular 2D
+                  DMS_HALL, DMS_ANDM, ATM_XCO2, OCN_FCO2, ATM_FCO2, OCN_RHOSW, OCN_SCHCO2,           &
+                  OCN_KWCO2, OCN_K0, CO2STARAIR, OCN_DPCO2,                                          & ! end of regular 2D
                   TPP3, DETFLUX3, REMIN3N, PH3, OM_CAL3,                                             & ! end of regular 3D
 ! AXY (11/11/16): additional CMIP6 2D diagnostics
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 8131)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 8132)
@@ -42,5 +42,5 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE sbc_oce, ONLY: lk_oasis 
-   USE oce,     ONLY: CO2Flux_out_cpl, DMS_out_cpl  !! Coupling variable
+   USE oce,     ONLY: CO2Flux_out_cpl, DMS_out_cpl, chloro_out_cpl  !! Coupling variable
 
    IMPLICIT NONE
@@ -247,5 +247,5 @@
       !! JPALM 14-06-2016 -- add CO2 flux and DMS surf through the restart
       !!                  -- needed for the coupling with atm
-      IF( iom_varid( numrtr, 'B_DMS_srf', ldstop = .FALSE. ) > 0 ) THEN
+      IF( iom_varid( numrtr, 'N_DMS_srf', ldstop = .FALSE. ) > 0 ) THEN
          IF(lwp) WRITE(numout,*) 'DMS surf concentration - reading in ...'
          CALL iom_get( numrtr, jpdom_autoglo, 'B_DMS_srf',  zb_dms_srf(:,:)  )
@@ -271,4 +271,19 @@
       IF (lk_oasis) THEN
          CO2Flux_out_cpl(:,:) =  zn_co2_flx(:,:)   !! Coupling variable
+      END IF
+      !!
+      !! JPALM 02-06-2017 -- in complement to DMS surf 
+      !!                  -- the atm model needs surf Chl 
+      !!                     as proxy of org matter from the ocean
+      !!                  -- needed for the coupling with atm
+      IF( iom_varid( numrtr, 'N_CHL_srf', ldstop = .FALSE. ) > 0 ) THEN
+         IF(lwp) WRITE(numout,*) 'Chl surf concentration - reading in ...'
+         CALL iom_get( numrtr, jpdom_autoglo, 'N_CHL_srf',  zn_chl_srf(:,:)  )
+      ELSE
+         IF(lwp) WRITE(numout,*) 'Chl surf concentration - setting to zero ...'
+         zn_chl_srf(:,:)  = 0.0
+      ENDIF
+      IF (lk_oasis) THEN
+         chloro_out_cpl(:,:) = zn_chl_srf(:,:)        !! Coupling variable
       END IF
       !!
@@ -282,4 +297,5 @@
       call trc_rst_dia_stat(zn_dms_srf(:,:), 'DMS surf')
       call trc_rst_dia_stat(zn_co2_flx(:,:), 'CO2 flux')
+      call trc_rst_dia_stat(zn_chl_srf(:,:), 'CHL surf')
       !!  
       !! JPALM 14-06-2016 -- add Carbonate chenistry variables through the restart
@@ -441,4 +457,5 @@
       CALL iom_rstput( kt, nitrst, numrtw, 'B_CO2_flx',  zb_co2_flx(:,:)  )
       CALL iom_rstput( kt, nitrst, numrtw, 'N_CO2_flx',  zn_co2_flx(:,:)  )
+      CALL iom_rstput( kt, nitrst, numrtw, 'N_CHL_srf',  zn_chl_srf(:,:)  )
       !!
       !! calculate stats on these fields
@@ -451,4 +468,5 @@
       call trc_rst_dia_stat(zn_dms_srf(:,:), 'DMS surf')
       call trc_rst_dia_stat(zn_co2_flx(:,:), 'CO2 flux')
+      call trc_rst_dia_stat(zn_chl_srf(:,:), 'CHL surf')
       !!
       IF(lwp) WRITE(numout,*) ' MEDUSA averaged prop. for dust and iron dep.'